# coding: utf-8

"""
    Rest PKI Core API

    <b><i>Para Português, <a href=\"https://docs.lacunasoftware.com/pt-br/articles/rest-pki/core/integration/get-started\">clique aqui</a></i></b>  <p>   <a href=\"https://docs.lacunasoftware.com/en-us/articles/rest-pki/core/\">Rest PKI Core</a> is an upcoming version of   <a href=\"https://docs.lacunasoftware.com/en-us/articles/rest-pki/\">Rest PKI</a> that will have extended compatibility with environments and databases.  </p>  <p>   In addition to Windows Server (which is already supported by Rest PKI), Rest PKI Core will also run on <b>Linux</b> (Debian- and RedHat-based distributions)   and on <b>Docker</b>. As for database servers, in addition to SQL Server, <b>PostgreSQL</b> will also be supported.  </p>  <p>   <b>Before getting started, see the integration overview on the <a href=\"https://docs.lacunasoftware.com/en-us/articles/rest-pki/core/integration/\">Integration Guide</a></b>  </p>  <p>   For questions regarding the usage of this API, please reach us at <a href=\"https://lacuna.help/\">lacuna.help</a>  </p>    <h2>Parameters</h2>  <p>   You will need the following parameters:  </p>  <ul>   <li><b>Endpoint</b>: address of the Rest PKI Core instance that will be used</li>   <li><b>API Key</b>: authorization key for using the API</li>  </ul>  <p>   The <span class=\"model\">endpoint</span> must be prefixed to all relative URLs mentioned here. As for the <span class=\"model\">API Key</span>, see how to use it below.  </p>    <h2>Authentication</h2>  <p>   The API key must be sent on the <span class=\"model\">X-Api-Key</span> header on each request:  </p>    <!-- unfortunately, class \"example microlight\" doesn't seem to work here -->  <pre style=\"font-size: 12px; padding: 10px; border-radius: 4px; background: #41444e; font-weight: 600; color: #fff;\">  X-Api-Key: yourapp|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx  </pre>    <h2>HTTP Codes</h2>    <p>   The APIs will return the following HTTP codes:  </p>    <table>   <thead>    <tr>     <th>Code</th>     <th>Description</th>    </tr>   </thead>   <tbody>    <tr>     <td><strong class=\"model-title\">200 (OK)</strong></td>     <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>    </tr>    <tr>     <td><strong class=\"model-title\">400 (Bad Request)</strong></td>     <td>Syntax error. For instance, when a required field was not provided</td>    </tr>    <tr>     <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>     <td>API key not provided or invalid</td>    </tr>    <tr>     <td><strong class=\"model-title\">403 (Forbidden)</strong></td>     <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>    </tr>    <tr>     <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>     <td>API error. The response body is an <a href=\"#model-ErrorModelV2\" class=\"model\">ErrorModelV2</a>    </tr>    <tr>     <td><strong class=\"model-title\">500 (Internal Server Error)</strong></td>     <td>An unexpected error occurred. The <span class=\"model\">exceptionCode</span> contained on the response body may be of help for our support team during diagnostic.</td>    </tr>   </tbody>  </table>    <h3>Error Codes</h3>    <p>   Some of the error codes returned in the <span class=\"model\">code</span> field of an <a href=\"#model-ErrorModelV2\" class=\"model\">ErrorModelV2</a>   (body of responses with HTTP status code 422) are provided below*:  </p>    <table>   <thead>    <tr>     <th>Code</th>     <th>Description</th>    </tr>   </thead>   <tbody>    <tr>     <td class=\"model\">DocumentNotFound</td>     <td>A referenced document was not found (check the document ID)</td>    </tr>    <tr>     <td class=\"model\">SecurityContextNotFound</td>     <td>A referenced security context was not found (check the security context ID)</td>    </tr>    <tr>     <td class=\"model\">SignatureSessionNotFound</td>     <td>A referenced signature session was not found (check the signature session ID)</td>    </tr>    <tr>     <td class=\"model\">BadSignatureSessionOperation</td>     <td>The operation is invalid for the current signature session or document status. For instance, trying to await the session's completion if it is still <span class=\"model\">Pending</span> results in this error</td>    </tr>    <tr>     <td class=\"model\">BackgroundProcessing</td>     <td>The operation cannot be completed at this time because the resource is being processed in background</td>    </tr>    <tr>     <td class=\"model\">SignatureSessionTokenRequired</td>     <td>The signature session token was not passed on the <span class=\"model\">X-Signature-Session-Token</span> request header</td>    </tr>    <tr>     <td class=\"model\">BadSignatureSessionToken</td>     <td>An invalid signature session token was passed on the <span class=\"model\">X-Signature-Session-Token</span> request header. Check your application for possible corruption of the session token, which may contain characters <span class=\"code\">-</span> (hyphen) and <span class=\"code\">_</span> (underscore)</td>    </tr>    <tr>     <td class=\"model\">ExpiredSignatureSessionToken</td>     <td>An expired signature session token was passed on the <span class=\"model\">X-Signature-Session-Token</span> request header. Signature session tokens are normally valid for 4 hours.</td>    </tr>   </tbody>  </table>    <p style=\"font-size: 0.9em\">   *The codes shown above are the most common error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning.  </p>    <h2>Culture / Internationalization (i18n)</h2>  <p>The <span class=\"model\">Accept-Language</span> request header is observed by this API. The following cultures are supported:</p>  <ul>   <li><span class=\"code\">en-US</span> (or simply <span class=\"code\">en</span>)</li>   <li><span class=\"code\">pt-BR</span> (or simply <span class=\"code\">pt</span>)</li>  </ul>  <p><i>Notice: error messages are not affected by this header and therefore should not be displayed to users, being better suited for logging.</i></p>  

    The version of the OpenAPI document: 2.1.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from setuptools import setup, find_packages  # noqa: H301

# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools
NAME = "restpki_ng_python_client"
VERSION = "0.9.1-rc1"
PYTHON_REQUIRES = ">=3.7"
REQUIRES = [
    "urllib3<2.1.0,>=1.24.3",
    "python-dateutil",
    "pydantic >= 2",
    "typing-extensions >= 4.7.1",
]

setup(
    name=NAME,
    version=VERSION,
    description="Rest PKI Core API",
    author="OpenAPI Generator community",
    author_email="team@openapitools.org",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "Rest PKI Core API"],
    install_requires=REQUIRES,
    packages=find_packages(exclude=["test", "tests"]),
    include_package_data=True,
    long_description_content_type='text/markdown',
    long_description="""\
    &lt;b&gt;&lt;i&gt;Para Português, &lt;a href&#x3D;\&quot;https://docs.lacunasoftware.com/pt-br/articles/rest-pki/core/integration/get-started\&quot;&gt;clique aqui&lt;/a&gt;&lt;/i&gt;&lt;/b&gt;  &lt;p&gt;   &lt;a href&#x3D;\&quot;https://docs.lacunasoftware.com/en-us/articles/rest-pki/core/\&quot;&gt;Rest PKI Core&lt;/a&gt; is an upcoming version of   &lt;a href&#x3D;\&quot;https://docs.lacunasoftware.com/en-us/articles/rest-pki/\&quot;&gt;Rest PKI&lt;/a&gt; that will have extended compatibility with environments and databases.  &lt;/p&gt;  &lt;p&gt;   In addition to Windows Server (which is already supported by Rest PKI), Rest PKI Core will also run on &lt;b&gt;Linux&lt;/b&gt; (Debian- and RedHat-based distributions)   and on &lt;b&gt;Docker&lt;/b&gt;. As for database servers, in addition to SQL Server, &lt;b&gt;PostgreSQL&lt;/b&gt; will also be supported.  &lt;/p&gt;  &lt;p&gt;   &lt;b&gt;Before getting started, see the integration overview on the &lt;a href&#x3D;\&quot;https://docs.lacunasoftware.com/en-us/articles/rest-pki/core/integration/\&quot;&gt;Integration Guide&lt;/a&gt;&lt;/b&gt;  &lt;/p&gt;  &lt;p&gt;   For questions regarding the usage of this API, please reach us at &lt;a href&#x3D;\&quot;https://lacuna.help/\&quot;&gt;lacuna.help&lt;/a&gt;  &lt;/p&gt;    &lt;h2&gt;Parameters&lt;/h2&gt;  &lt;p&gt;   You will need the following parameters:  &lt;/p&gt;  &lt;ul&gt;   &lt;li&gt;&lt;b&gt;Endpoint&lt;/b&gt;: address of the Rest PKI Core instance that will be used&lt;/li&gt;   &lt;li&gt;&lt;b&gt;API Key&lt;/b&gt;: authorization key for using the API&lt;/li&gt;  &lt;/ul&gt;  &lt;p&gt;   The &lt;span class&#x3D;\&quot;model\&quot;&gt;endpoint&lt;/span&gt; must be prefixed to all relative URLs mentioned here. As for the &lt;span class&#x3D;\&quot;model\&quot;&gt;API Key&lt;/span&gt;, see how to use it below.  &lt;/p&gt;    &lt;h2&gt;Authentication&lt;/h2&gt;  &lt;p&gt;   The API key must be sent on the &lt;span class&#x3D;\&quot;model\&quot;&gt;X-Api-Key&lt;/span&gt; header on each request:  &lt;/p&gt;    &lt;!-- unfortunately, class \&quot;example microlight\&quot; doesn&#39;t seem to work here --&gt;  &lt;pre style&#x3D;\&quot;font-size: 12px; padding: 10px; border-radius: 4px; background: #41444e; font-weight: 600; color: #fff;\&quot;&gt;  X-Api-Key: yourapp|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx  &lt;/pre&gt;    &lt;h2&gt;HTTP Codes&lt;/h2&gt;    &lt;p&gt;   The APIs will return the following HTTP codes:  &lt;/p&gt;    &lt;table&gt;   &lt;thead&gt;    &lt;tr&gt;     &lt;th&gt;Code&lt;/th&gt;     &lt;th&gt;Description&lt;/th&gt;    &lt;/tr&gt;   &lt;/thead&gt;   &lt;tbody&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;200 (OK)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;Request processed successfully. The response is different for each API, please refer to the operation&#39;s documentation&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;400 (Bad Request)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;Syntax error. For instance, when a required field was not provided&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;401 (Unauthorized)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;API key not provided or invalid&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;403 (Forbidden)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;API key is valid, but the application has insufficient permissions to complete the requested operation&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;422 (Unprocessable Entity)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;API error. The response body is an &lt;a href&#x3D;\&quot;#model-ErrorModelV2\&quot; class&#x3D;\&quot;model\&quot;&gt;ErrorModelV2&lt;/a&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;500 (Internal Server Error)&lt;/strong&gt;&lt;/td&gt;     &lt;td&gt;An unexpected error occurred. The &lt;span class&#x3D;\&quot;model\&quot;&gt;exceptionCode&lt;/span&gt; contained on the response body may be of help for our support team during diagnostic.&lt;/td&gt;    &lt;/tr&gt;   &lt;/tbody&gt;  &lt;/table&gt;    &lt;h3&gt;Error Codes&lt;/h3&gt;    &lt;p&gt;   Some of the error codes returned in the &lt;span class&#x3D;\&quot;model\&quot;&gt;code&lt;/span&gt; field of an &lt;a href&#x3D;\&quot;#model-ErrorModelV2\&quot; class&#x3D;\&quot;model\&quot;&gt;ErrorModelV2&lt;/a&gt;   (body of responses with HTTP status code 422) are provided below*:  &lt;/p&gt;    &lt;table&gt;   &lt;thead&gt;    &lt;tr&gt;     &lt;th&gt;Code&lt;/th&gt;     &lt;th&gt;Description&lt;/th&gt;    &lt;/tr&gt;   &lt;/thead&gt;   &lt;tbody&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;DocumentNotFound&lt;/td&gt;     &lt;td&gt;A referenced document was not found (check the document ID)&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;SecurityContextNotFound&lt;/td&gt;     &lt;td&gt;A referenced security context was not found (check the security context ID)&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;SignatureSessionNotFound&lt;/td&gt;     &lt;td&gt;A referenced signature session was not found (check the signature session ID)&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;BadSignatureSessionOperation&lt;/td&gt;     &lt;td&gt;The operation is invalid for the current signature session or document status. For instance, trying to await the session&#39;s completion if it is still &lt;span class&#x3D;\&quot;model\&quot;&gt;Pending&lt;/span&gt; results in this error&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;BackgroundProcessing&lt;/td&gt;     &lt;td&gt;The operation cannot be completed at this time because the resource is being processed in background&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;SignatureSessionTokenRequired&lt;/td&gt;     &lt;td&gt;The signature session token was not passed on the &lt;span class&#x3D;\&quot;model\&quot;&gt;X-Signature-Session-Token&lt;/span&gt; request header&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;BadSignatureSessionToken&lt;/td&gt;     &lt;td&gt;An invalid signature session token was passed on the &lt;span class&#x3D;\&quot;model\&quot;&gt;X-Signature-Session-Token&lt;/span&gt; request header. Check your application for possible corruption of the session token, which may contain characters &lt;span class&#x3D;\&quot;code\&quot;&gt;-&lt;/span&gt; (hyphen) and &lt;span class&#x3D;\&quot;code\&quot;&gt;_&lt;/span&gt; (underscore)&lt;/td&gt;    &lt;/tr&gt;    &lt;tr&gt;     &lt;td class&#x3D;\&quot;model\&quot;&gt;ExpiredSignatureSessionToken&lt;/td&gt;     &lt;td&gt;An expired signature session token was passed on the &lt;span class&#x3D;\&quot;model\&quot;&gt;X-Signature-Session-Token&lt;/span&gt; request header. Signature session tokens are normally valid for 4 hours.&lt;/td&gt;    &lt;/tr&gt;   &lt;/tbody&gt;  &lt;/table&gt;    &lt;p style&#x3D;\&quot;font-size: 0.9em\&quot;&gt;   *The codes shown above are the most common error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning.  &lt;/p&gt;    &lt;h2&gt;Culture / Internationalization (i18n)&lt;/h2&gt;  &lt;p&gt;The &lt;span class&#x3D;\&quot;model\&quot;&gt;Accept-Language&lt;/span&gt; request header is observed by this API. The following cultures are supported:&lt;/p&gt;  &lt;ul&gt;   &lt;li&gt;&lt;span class&#x3D;\&quot;code\&quot;&gt;en-US&lt;/span&gt; (or simply &lt;span class&#x3D;\&quot;code\&quot;&gt;en&lt;/span&gt;)&lt;/li&gt;   &lt;li&gt;&lt;span class&#x3D;\&quot;code\&quot;&gt;pt-BR&lt;/span&gt; (or simply &lt;span class&#x3D;\&quot;code\&quot;&gt;pt&lt;/span&gt;)&lt;/li&gt;  &lt;/ul&gt;  &lt;p&gt;&lt;i&gt;Notice: error messages are not affected by this header and therefore should not be displayed to users, being better suited for logging.&lt;/i&gt;&lt;/p&gt;  
    """,  # noqa: E501
    package_data={"restpki_ng_python_client": ["py.typed"]},
)
